//===========================================================================================
void miniSendConfigurations()
{
  //need to build up the data that will be sent
  //Data Mode - DMX Address Lo - DMX Address Hi - User Pixel Amount Lo - User Pixel Amount Hi -User Serial Baud - Flags MSB LED Enabled

  //Pixel Chipset Type
  if (miniDropList3.getSelectedIndex() == 2) //check firmware version
  {
    //firmware version 1
    //0= 2801, 1= 2803, 2= 2811, 3=2812, 4=2812B, 5=LDP8806, 6=LPD6803
    if (miniDropList1.getSelectedIndex() == 0 || miniDropList1.getSelectedIndex() == 1) DataArray[0] = 2; //Firmware ID for standard SPI devices is 2
    else if (miniDropList1.getSelectedIndex() == 2 || miniDropList1.getSelectedIndex() == 3 || miniDropList1.getSelectedIndex() == 4) DataArray[0] = 0; //Firmware ID for 800KHz World Semi Pixels is 0
    else if (miniDropList1.getSelectedIndex() == 5) DataArray[0] = 4; //Firmware ID for LPD8806   

    if (int(miniTextField2.getText()) > 41) miniTextField2.setText("41");
  } else if (miniDropList3.getSelectedIndex() == 1)
  {
    //firmware version 2
    //0= 2801, 1= 2803, 2= 2811, 3=2812, 4=2812B, 5=LDP8806, 6=LPD6803
    if (miniDropList1.getSelectedIndex() == 0 || miniDropList1.getSelectedIndex() == 1) DataArray[0] = 2; //Firmware ID for standard SPI devices is 2
    else if (miniDropList1.getSelectedIndex() == 2 || miniDropList1.getSelectedIndex() == 3 || miniDropList1.getSelectedIndex() == 4) DataArray[0] = 0; //Firmware ID for 800KHz World Semi Pixels is 0
    else if (miniDropList1.getSelectedIndex() == 5) DataArray[0] = 4; //Firmware ID for LPD8806
    else if (miniDropList1.getSelectedIndex() == 6) DataArray[0] = 6; //LPD6803

    if (int(miniTextField2.getText()) > 57) miniTextField2.setText("57");
  } else
  {
    //firmware version 3
    //0= 2801, 1= 2803, 2= 2811, 3=2812, 4=2812B, 5=LDP8806, 6=LPD6803
    if (miniDropList1.getSelectedIndex() == 0 || miniDropList1.getSelectedIndex() == 1) DataArray[0] = 2; //Firmware ID for standard SPI devices is 2
    else if (miniDropList1.getSelectedIndex() == 2 || miniDropList1.getSelectedIndex() == 3 || miniDropList1.getSelectedIndex() == 4) DataArray[0] = 0; //Firmware ID for 800KHz World Semi Pixels is 0
    else if (miniDropList1.getSelectedIndex() == 5) DataArray[0] = 4; //Firmware ID for standard SPI devices is 2
    else if (miniDropList1.getSelectedIndex() == 6) DataArray[0] = 6; //LPD6803
    else if (miniDropList1.getSelectedIndex() == 7) DataArray[0] = 8; //APA102

    if (int(miniTextField2.getText()) > 57) miniTextField2.setText("57");
  }

  //DMX Address 
  DataArray[1] = (int(miniTextField1.getText()) & 0xFF); //LSB
  DataArray[2] = ((int(miniTextField1.getText()) >> 8) & 0xFF); //MSB
  //DMX Pixel Amount
  DataArray[3] = (int(miniTextField2.getText()) & 0xFF); //LSB
  DataArray[4] =((int(miniTextField2.getText()) >> 8) & 0xFF); //MSB

  //Baud Rate
  if (miniCheckBox1.isSelected()) {
    //use TextField for custom SPBRG value if box is checked
    DataArray[5] = 0; //indicates to use the custom value in DataArray[8]
    DataArray[6] =  (int(miniTextField3.getText()));
    println(miniTextField3.getText()+" Loaded Custom SPBRG value "+parseInt(miniTextField3.getText()));
  } else { //else use drop down and SPBRG values for 32mhz PIC processors with BRG16 set
    DataArray[5] = miniDropList2.getSelectedIndex()+1;
    DataArray[6] = 0; //not used so leave it 0
  }

  if (miniCheckBox2.isSelected()) DataArray[7] = 0; //binary 00000000
  else DataArray[7] = 128; //binary 10000000 //Enable LED for RX

  //when sending bytes one at a time they are technically send in seperate USB packets
  //   so there is a delay of a few mS between them, though the device could have them sent all
  //    back to back and still recieve correctly.

  myPort.write(123); //just some random numbers chosen that have to arrive first or 
  myPort.write(253);  // the firmware won't allow a write, to hopefully prevent accidental confiurations
  myPort.write(82);
  myPort.write(7);  
  //end framing bytes

  myPort.write(DataArray[0]); //DataMode
  myPort.write(DataArray[1]); //DMX Adr Lo
  myPort.write(DataArray[2]); //DMX Adr Hi
  myPort.write(DataArray[3]);//Pixel Amount DMX, Lo
  myPort.write(DataArray[4]);//Pixel Amount DMX, Hi
  myPort.write(DataArray[5]); //UserBaud ID, 0 means use custom SPBRG value
  myPort.write(DataArray[6]); //custom SPBRG value, can be any value if not used
  myPort.write(miniSlider1.getValueI()); //PR2 Value
  myPort.write(DataArray[7]); //flags, currently only holding enable RX LED
}

//===========================================================================================
void miniplusSendConfigurations()
{
  //same as mini but with higher pixel amount??
} //end miniplusSendConfigurations()

//===========================================================================================

void ionSendConfigurations()
{
  switch(ionDropList5.getSelectedIndex()) //LEDMode
  {
  case 0: //RX
    tempFlags = tempFlags | 0x08;
    break;
  case 1: //Stand-Alone
    tempFlags = tempFlags | 0x04;
    break;
  case 2: //Both
    tempFlags = tempFlags | 0x0C;
    break;
  case 3: //disabled
    //no change both 00
    break;
  }

  switch(ionDropList6.getSelectedIndex()) //Auto Detect Data
  {
  case 0: //None
    //both ID flag and Autodetect stay 0
    break;
  case 1: //Autodetect DMX
    tempFlags = tempFlags | 0x10; //Set AutoDetectID Flag to 1
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  case 2: //Autodetect Serial
    //AutoDetectID Flag stays 0 for serial
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  }//end switch

  if (ionDropList7.getSelectedIndex() > 0)  temp2Flags = temp2Flags | 0x08; //fAccMeterAutoShutOff ConfigFlags.bits.b10
  if (ionCheckBox1.isSelected())           temp2Flags = temp2Flags | 0x10;//fAccMeterMovement ConfigFlags.bits.b11
  if (ionDropList8.getSelectedIndex() > 0) temp2Flags = temp2Flags | 0x20; //fAccMeterDoubleTap ConfigFlags.bits.b12

  //start sending bytes
  final int cAccMeterShutOffVals[] = {
    1, 16, 32, 64, 96, 128, 192, 250
  };

  myPort.write((int(ionTextField1.getText()) >> 8) & 0xFF); //DMXAdr MSB
  myPort.write(int(ionTextField1.getText()) & 0xFF); //DMXAdr LSB
  myPort.write(ionDropList2.getSelectedIndex()); //DMX Mode ID
  myPort.write(ionDropList4.getSelectedIndex()); //BaudRateID  
  myPort.write(temp2Flags & 0xFF); //MSB ConfigFlags
  myPort.write(tempFlags & 0xFF); //LSB Config2Flags

  myPort.write(ionDropList1.getSelectedIndex()); //Pixel Type
  myPort.write(ionDropList3.getSelectedIndex()); //Global Color Swap
  myPort.write(cAccMeterShutOffVals[ionDropList7.getSelectedIndex()]);//accmeter timeout value
  myPort.write(ionDropList8.getSelectedIndex());//accmeter double tap mode
} //end ionSendConfigurations()

//===========================================================================================

void chan30SendConfigurations()
{
  switch(chan30DropList4.getSelectedIndex())
  {
  case 0: //Always On
    //00 is always on
    break;
  case 1: //Countdown
    tempFlags = tempFlags | 0x01;
    break;
  case 2: //Dim
    tempFlags = tempFlags | 0x02;
    break;
  case 3: //both
    tempFlags = tempFlags | 0x03;
    break;
  }

  switch(chan30DropList3.getSelectedIndex()) //LEDMode
  {
  case 0: //RX
    tempFlags = tempFlags | 0x08;
    break;
  case 1: //Stand-Alone
    tempFlags = tempFlags | 0x04;
    break;
  case 2: //Both
    tempFlags = tempFlags | 0x0C;
    break;
  case 3: //disabled
    //no change both 00
    break;
  }   

  switch(chan30DropList5.getSelectedIndex())
  {
  case 0: //None
    //both ID flag and Autodetect stay 0
    break;
  case 1: //Autodetect DMX
    tempFlags = tempFlags | 0x10; //Set AutoDetectID Flag to 1
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  case 2: //Autodetect Serial
    //AutoDetectID Flag stays 0 for serial
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  }//end switch

  if (chan30CheckBox2.isSelected()) tempFlags = tempFlags | 0x40;//f8or16FBit
  if (chan30CheckBox1.isSelected())  tempFlags = tempFlags | 0x80;//fRS485Enable

  switch(chan30DropList2.getSelectedIndex())
  {
  case 0: //None
    //both ID flag and Autodetect stay 0    
    break;
  case 1: //Master Full Packets
    temp2Flags = temp2Flags | 0x01; //fMasterEnable
    temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)
    break;
  case 2: //Master Partial Packets
    temp2Flags = temp2Flags | 0x01; //fMasterEnable
    //fMasterFullPkts(1 is Full, 0 is partial) - leave it 0
    break;
  }//end switch

  //start sending bytes
  myPort.write((int(chan30TextField1.getText()) >> 8) & 0xFF); //DMXAdr MSB
  myPort.write(int(chan30TextField1.getText()) & 0xFF); //DMXAdr LSB
  myPort.write(chan30DropList1.getSelectedIndex()); //DMX Mode ID
  myPort.write(chan30DropList6.getSelectedIndex()); //BaudRateID
  myPort.write(temp2Flags & 0xFF); //MSB ConfigFlags
  myPort.write(tempFlags & 0xFF); //LSB Config2Flags
} //end chan30SendConfigurations

//===========================================================================================

void dmxwashSendConfigurations()
{
  //for 4 chan DMX
  switch(dmxwashDropList3.getSelectedIndex())
  {
  case 0: //Always On
    //00 is always on
    break;
  case 1: //Countdown
    tempFlags = tempFlags | 0x02;
    break;
  case 2: //Dim
    tempFlags = tempFlags | 0x01;
    break;
  case 3: //both
    tempFlags = tempFlags | 0x03;
    break;
  }

  switch(dmxwashDropList5.getSelectedIndex())
  {
  case 0: //None/Disabled
    //already 0
    break;
  case 1: //Auto-Detect DMX
    tempFlags = tempFlags | 0x04; //set flag, 2
    break;
  }//end switch

  switch(dmxwashDropList2.getSelectedIndex())
  {
  case 0: //None
    //partial packets is 0
    //TransmitMode is 0  
    break;
  case 1: //Master Full Packets
    tempFlags = tempFlags | 0x60;  //set TransmitMode and to Full Packets
    break;
  case 2: //Master Partial Packets
    tempFlags = tempFlags | 0x20;  //set TransmitMode and to Partial Packets
    break;
  } //end switch

  if (dmxwashCheckBox2.isSelected())  tempFlags = tempFlags | 0x08;//fRS485Enable
  if (dmxwashCheckBox1.isSelected())  tempFlags = tempFlags | 0x10;//fSerailorDMX

  //start sending
  myPort.write((int(dmxwashTextField1.getText()) >> 8) & 0xFF); //DMXAdr MSB
  myPort.write(int(dmxwashTextField1.getText()) & 0xFF); //DMXAdr LSB

  myPort.write(tempFlags & 0xFF); //ConfigFlags
  myPort.write(dmxwashDropList1.getSelectedIndex()); //DMX Mode ID

  //special configuration uploads allows access to:
  //sequence number not sent
  //standalone type not sent
  //PWM rate not sent

  myPort.write(dmxwashDropList4.getSelectedIndex()); //BaudRateID
}
//===========================================================================================
void octoSendConfigurations()
{
  //#define TimeOutEnabledMSB ConfigFlags, 0 ;00 = Disabled, 01 = 5 Mins
  //#define TimeOutEnabledLSB ConfigFlags, 1 ;10 = 10 Mins, 11 = 15 Mins

    println("octoSendConfigurations()");

  switch(octoDropList1.getSelectedIndex())
  {
  case 0: //Disabled

    break;
  case 1: //5 Minutes
    tempFlags = 0x01; 
    break;
  case 2: //10 Minutes
    tempFlags = tempFlags | 0x02; 
    break;
  case 3: //15 Minutes
    tempFlags = tempFlags | 0x03; 
    break;
  }//end switch

  //octoseq takes configuration data differently since there is only one byte it sends it with the command
  //the software just sent the command init, but it actually cleared the config flags, this will send the new ones
  cmdByte = 1; //request configuration upload
  cmdData[0] = tempFlags;
  cmdData[1] = 0;  
  cmdData[2] = 0;
  cmdData[3] = 0;
  RequestCommand();
} //octoSendConfigurations()
//===========================================================================================
void rgbwSendConfigurations()
{
  switch(rgbwDropList3.getSelectedIndex())
  {
  case 0: //None
    //both ID flag and Autodetect stay 0
    break;
  case 1: //Autodetect DMX
    tempFlags = tempFlags | 0x10; //Set AutoDetectID Flag to 1
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  case 2: //Autodetect Serial
    //AutoDetectID Flag stays 0 for serial
    tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
    break;
  }//end switch

  switch(rgbwDropList2.getSelectedIndex())
  {
  case 0: //None
    //both ID flag and Autodetect stay 0

      break;
  case 1: //Master Full Pkts 8-Bit
    temp2Flags = temp2Flags | 0x01; //fMasterEnable
    temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)
    //fMaster16Bit stays 0  
    break;
  case 2: //Master Full Pkts 16-Bit
    temp2Flags = temp2Flags | 0x01; //fMasterEnable
    temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)  
    temp2Flags = temp2Flags | 0x04; //fMaster16Bit
    break;
  case 3:  //Master Partial Pkts 8-Bit
    temp2Flags = temp2Flags | 0x01; //fMasterEnable  
    //fMasterFullPkts stays 0(1 is Full, 0 is partial)
    //fMaster16Bit stays 0
    break;  
  case 4:  //Master Partial Pkts 16-Bit
    temp2Flags = temp2Flags | 0x01; //fMasterEnable  
    //fMasterFullPkts stays 0(1 is Full, 0 is partial)  
    temp2Flags = temp2Flags | 0x04; //fMaster16Bit  
    break;
  }//end switch

  if (rgbwCheckBox1.isSelected())  tempFlags = tempFlags | 0x08;//fRS485Enable   
  if (rgbwCheckBox2.isSelected()) tempFlags = tempFlags | 0x40;//f8or16FBit

  //start sending bytes
  myPort.write((int(rgbwTextField1.getText()) >> 8) & 0xFF); //DMXAdr MSB
  myPort.write(int(rgbwTextField1.getText()) & 0xFF); //DMXAdr LSB
  myPort.write(rgbwDropList1.getSelectedIndex()); //DMX Mode ID
  myPort.write(rgbwDropList4.getSelectedIndex()); //BaudRateID
  myPort.write(temp2Flags & 0xFF); //MSB ConfigFlags
  myPort.write(tempFlags & 0xFF); //LSB Config2Flags

  println("SENT");
} //end rgbwSendConfigurations()
//===========================================================================================

